﻿#nullable enable

using System.Collections.Concurrent;
using Microsoft.Extensions.Logging;

namespace Unity.Extensions.Logging
{
    public class UnityLoggerProvider : ILoggerProvider
    {
        private readonly ConcurrentDictionary<string, UnityLogger> _loggers = new();
        private readonly UnityLogFormatter _formatter = new();

        public ILogger CreateLogger(string name)
        {
            return _loggers.TryGetValue(name, out var logger)
                ? logger
                : _loggers.GetOrAdd(name, new UnityLogger(name, UnityEngine.Debug.unityLogger, _formatter));
        }
        
        public void Dispose()
        {
        }
    }
}